#!/bin/bash

SCRIPT=$1

export ORACLE_SID=ora11a

export ORACLE_BASE=/u01/app/taira
export ORACLE_HOME=$ORACLE_BASE/product/11.2.0/dbhome_2
export PATH=$PATH:$ORACLE_HOME/bin

export ORA_NLS10=$ORACLE_HOME/nls/data
export NLS_LANG=American_Japan.AL32UTF8
export NLS_DATE_FORMAT='syyyy/mm/dd hh24:mi:ss'

cd `dirname $0`

sqlplus -S "/ as sysdba" <<_EOF_ > _snap.tmp
SET NEWPAGE NONE
SET HEADING OFF
SET FEEDBACK OFF
COL SNAPTIME FORMAT A20
SELECT DBID, INSTANCE_NUMBER, SNAP_ID, SNAPTIME
FROM (SELECT DBID, INSTANCE_NUMBER, SNAP_ID,
             TO_CHAR(END_INTERVAL_TIME, 'YYYYMMDD-HH24MISS') SNAPTIME
      FROM DBA_HIST_SNAPSHOT
      ORDER BY SNAP_ID DESC)
WHERE ROWNUM <= 2
/
_EOF_

DBID=`head -1 _snap.tmp | awk '{print $1}'`
INSTANCE_NUMBER=`head -1 _snap.tmp | awk '{print $2}'`
END_SNAP_ID=`head -1 _snap.tmp | awk '{print $3}'`
BEGIN_SNAP_ID=`tail -1 _snap.tmp | awk '{print $3}'`
REPORT=logs/awr_`tail -1 _snap.tmp | awk '{print $4}'`.html

sqlplus -S "/ as sysdba" <<_EOF_ > /dev/null
SET NEWPAGE NONE
SET HEADING OFF
SET FEEDBACK OFF
SET TRIMSPOOL ON
SET LINES 8000
SPOOL $REPORT
SELECT OUTPUT
FROM TABLE(DBMS_WORKLOAD_REPOSITORY.AWR_REPORT_HTML(
           $DBID, $INSTANCE_NUMBER, $BEGIN_SNAP_ID, $END_SNAP_ID))
/
SPOOL OFF
_EOF_

