#!/bin/bash

export CLASSPATH=libs/sysbench.jar:libs/commons-cli-1.2.jar:libs/commons-dbcp-1.4.jar:libs/commons-pool-1.5.6.jar:libs/mysql-connector-java-5.1.18-bin.jar

WORKDIR=`pwd`
SERVER=k02c5
LOG_FILE=logs/mysql_`date +%Y%m%d-%H%M%S`.log
JAVA_OPT='-server -Xmx256m -Xms256m'
SYSBENCH_OPT='-oltpTableSize 1000000 -warmupTime 300 -measurementTime 300'
JDBC_URL_SERVER='-jdbcUrl jdbc:mysql://k02c5/sbtest?useServerPrepStmts=true'
JDBC_URL_CLIENT='-jdbcUrl jdbc:mysql://k02c5/sbtest'
JDBC_URL_NOPOOL_SERVER='-jdbcUrl jdbc:mysql://k02c5/sbtest?cacheServerConfiguration=true&useLocalSessionState=true&characterSetResults=UTF-8&useServerPrepStmts=true'
JDBC_URL_NOPOOL_CLIENT='-jdbcUrl jdbc:mysql://k02c5/sbtest?cacheServerConfiguration=true&useLocalSessionState=true&characterSetResults=UTF-8'
SLEEP_TIME=60

ssh $SERVER "touch $WORKDIR/lockfile"

(
ssh $SERVER "$WORKDIR/status_global.sh > /dev/null &"
ssh $SERVER "$WORKDIR/status_innodb.sh > /dev/null &"

echo '##### TEST 01 CBPs'
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL_SERVER
sleep $SLEEP_TIME

echo '##### TEST 02 CBPc'
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL_CLIENT
sleep $SLEEP_TIME

echo '##### TEST 03 CB-s'
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL_SERVER -usePreparedStatementPool false
sleep $SLEEP_TIME

echo '##### TEST 04 CB-c'
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL_CLIENT -usePreparedStatementPool false
sleep $SLEEP_TIME

echo '##### TEST 05 C---'
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL_CLIENT -usePreparedStatement false
sleep $SLEEP_TIME

echo '##### TEST 06 -B-s'
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL_NOPOOL_SERVER -useConnectionPool false -usePreparedStatementPool false
sleep $SLEEP_TIME

echo '##### TEST 07 -B-c'
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL_NOPOOL_CLIENT -useConnectionPool false -usePreparedStatementPool false
sleep $SLEEP_TIME

echo '##### TEST 08 ----'
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL_NOPOOL_CLIENT -useConnectionPool false -usePreparedStatement false
sleep $SLEEP_TIME
) | tee $LOG_FILE

ssh $SERVER "rm $WORKDIR/lockfile"
