#!/bin/bash

export CLASSPATH=libs/sysbench.jar:libs/commons-cli-1.2.jar:libs/commons-dbcp-1.4.jar:libs/commons-pool-1.5.6.jar:libs/ojdbc6.jar

WORKDIR=`pwd`
SERVER=k02c5
LOG_FILE=logs/oracle_`date +%Y%m%d-%H%M%S`.log
JAVA_OPT='-server -Xmx256m -Xms256m -Djava.security.egd=file:///dev/urandom'
SYSBENCH_OPT='-oltpTableSize 1000000 -warmupTime 300 -measurementTime 300'
JDBC_URL='-jdbcUrl jdbc:oracle:thin:@//k02c5/ora11a'
SLEEP_TIME=60

(
echo '##### TEST 01 CBPde'
ssh $SERVER $WORKDIR/sql.sh shared_disable.sql
ssh $SERVER $WORKDIR/sql.sh cursor_exact.sql
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
ssh $SERVER $WORKDIR/awr_report.sh
sleep $SLEEP_TIME

echo '##### TEST 02 CB-de'
ssh $SERVER $WORKDIR/sql.sh shared_disable.sql
ssh $SERVER $WORKDIR/sql.sh cursor_exact.sql
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL -usePreparedStatementPool false
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
ssh $SERVER $WORKDIR/awr_report.sh
sleep $SLEEP_TIME

echo '##### TEST 03 C--df'
ssh $SERVER $WORKDIR/sql.sh shared_disable.sql
ssh $SERVER $WORKDIR/sql.sh cursor_force.sql
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL -usePreparedStatement false
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
ssh $SERVER $WORKDIR/awr_report.sh
sleep $SLEEP_TIME

echo '##### TEST 04 C--de'
ssh $SERVER $WORKDIR/sql.sh shared_disable.sql
ssh $SERVER $WORKDIR/sql.sh cursor_exact.sql
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL -usePreparedStatement false
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
ssh $SERVER $WORKDIR/awr_report.sh
sleep $SLEEP_TIME

echo '##### TEST 05 -B-se'
ssh $SERVER $WORKDIR/sql.sh shared_enable.sql
ssh $SERVER $WORKDIR/sql.sh cursor_exact.sql
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL -useConnectionPool false -usePreparedStatementPool false
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
ssh $SERVER $WORKDIR/awr_report.sh
sleep $SLEEP_TIME

echo '##### TEST 06 -B-de'
ssh $SERVER $WORKDIR/sql.sh shared_disable.sql
ssh $SERVER $WORKDIR/sql.sh cursor_exact.sql
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL -useConnectionPool false -usePreparedStatementPool false
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
ssh $SERVER $WORKDIR/awr_report.sh
sleep $SLEEP_TIME

echo '##### TEST 07 ---sf'
ssh $SERVER $WORKDIR/sql.sh shared_enable.sql
ssh $SERVER $WORKDIR/sql.sh cursor_force.sql
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL -useConnectionPool false -usePreparedStatement false
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
ssh $SERVER $WORKDIR/awr_report.sh
sleep $SLEEP_TIME

echo '##### TEST 08 ---de'
ssh $SERVER $WORKDIR/sql.sh shared_disable.sql
ssh $SERVER $WORKDIR/sql.sh cursor_exact.sql
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
java $JAVA_OPT sysbench.Manager $SYSBENCH_OPT $JDBC_URL -useConnectionPool false -usePreparedStatement false
ssh $SERVER $WORKDIR/sql.sh awr_snapshot.sql
ssh $SERVER $WORKDIR/awr_report.sh
sleep $SLEEP_TIME

# RESTORE SETTINGS
ssh $SERVER $WORKDIR/sql.sh shared_disable.sql
ssh $SERVER $WORKDIR/sql.sh cursor_exact.sql
) | tee $LOG_FILE
