package sysbench;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class WorkerImplBind extends Worker {
	public WorkerImplBind(Manager manager, int workerId, int oltpTableSize, int oltpRangeSize) {
		super(manager, workerId, oltpTableSize, oltpRangeSize);
	}

	@Override
	public void executeTransaction(Connection connection) throws SQLException {
		PreparedStatement preparedStatement = null;
		ResultSet resultSet = null;

		try {
			int from = 0;
			int to = 0;

			// Point selects
			for (int i = 0; i < 10; i++) {
				preparedStatement = connection
						.prepareStatement("SELECT c FROM sbtest WHERE id = ?");
				preparedStatement.setInt(1, getRandomId());
				resultSet = preparedStatement.executeQuery();
				while (resultSet.next()) {
				}
				resultSet.close();
				preparedStatement.close();
			}

			// Simple ranges
			preparedStatement = connection
					.prepareStatement("SELECT c FROM sbtest WHERE id BETWEEN ? AND ?");
			from = getRangeRandomId();
			to = from + oltpRangeSize - 1;
			preparedStatement.setInt(1, from);
			preparedStatement.setInt(2, to);
			resultSet = preparedStatement.executeQuery();
			while (resultSet.next()) {
			}
			resultSet.close();
			preparedStatement.close();

			// Sum ranges
			preparedStatement = connection
					.prepareStatement("SELECT SUM(k) FROM sbtest WHERE id BETWEEN ? AND ?");
			from = getRangeRandomId();
			to = from + oltpRangeSize - 1;
			preparedStatement.setInt(1, from);
			preparedStatement.setInt(2, to);
			resultSet = preparedStatement.executeQuery();
			while (resultSet.next()) {
			}
			resultSet.close();
			preparedStatement.close();

			// Order ranges
			preparedStatement = connection
					.prepareStatement("SELECT c FROM sbtest WHERE id BETWEEN ? AND ? ORDER BY c");
			from = getRangeRandomId();
			to = from + oltpRangeSize - 1;
			preparedStatement.setInt(1, from);
			preparedStatement.setInt(2, to);
			resultSet = preparedStatement.executeQuery();
			while (resultSet.next()) {
			}
			resultSet.close();
			preparedStatement.close();

			// Distinct ranges
			preparedStatement = connection
					.prepareStatement("SELECT DISTINCT c FROM sbtest WHERE id BETWEEN ? AND ? ORDER BY c");
			from = getRangeRandomId();
			to = from + oltpRangeSize - 1;
			preparedStatement.setInt(1, from);
			preparedStatement.setInt(2, to);
			resultSet = preparedStatement.executeQuery();
			while (resultSet.next()) {
			}
			resultSet.close();
			preparedStatement.close();

			connection.rollback();

		} finally {
			if (resultSet != null) {
				try {
					resultSet.close();
				} catch (SQLException e) {
				}
			}

			if (preparedStatement != null) {
				try {
					preparedStatement.close();
				} catch (SQLException e) {
				}
			}
		}
	}
}
