package sysbench;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class WorkerImplLiteral extends Worker {
	public WorkerImplLiteral(Manager manager, int workerId, int oltpTableSize, int oltpRangeSize) {
		super(manager, workerId, oltpTableSize, oltpRangeSize);
	}

	@Override
	public void executeTransaction(Connection connection) throws SQLException {
		Statement statement = null;
		ResultSet resultSet = null;

		try {
			int from = 0;
			int to = 0;

			// Point selects
			for (int i = 0; i < 10; i++) {
				statement = connection.createStatement();
				resultSet = statement.executeQuery("SELECT c FROM sbtest WHERE id = "
						+ getRandomId());
				while (resultSet.next()) {
				}
				resultSet.close();
				statement.close();
			}

			// Simple ranges
			statement = connection.createStatement();
			from = getRangeRandomId();
			to = from + oltpRangeSize - 1;
			resultSet = statement.executeQuery("SELECT c FROM sbtest WHERE id BETWEEN " + from
					+ " AND " + to);
			while (resultSet.next()) {
			}
			resultSet.close();
			statement.close();

			// Sum ranges
			statement = connection.createStatement();
			from = getRangeRandomId();
			to = from + oltpRangeSize - 1;
			resultSet = statement.executeQuery("SELECT SUM(k) FROM sbtest WHERE id BETWEEN " + from
					+ " AND " + to);
			while (resultSet.next()) {
			}
			resultSet.close();
			statement.close();

			// Order ranges
			statement = connection.createStatement();
			from = getRangeRandomId();
			to = from + oltpRangeSize - 1;
			resultSet = statement.executeQuery("SELECT c FROM sbtest WHERE id BETWEEN " + from
					+ " AND " + to + " ORDER BY c");
			while (resultSet.next()) {
			}
			resultSet.close();
			statement.close();

			// Distinct ranges
			statement = connection.createStatement();
			from = getRangeRandomId();
			to = from + oltpRangeSize - 1;
			resultSet = statement.executeQuery("SELECT DISTINCT c FROM sbtest WHERE id BETWEEN "
					+ from + " AND " + to + " ORDER BY c");
			while (resultSet.next()) {
			}
			resultSet.close();
			statement.close();

			connection.rollback();

		} finally {
			if (resultSet != null) {
				try {
					resultSet.close();
				} catch (SQLException e) {
				}
			}

			if (statement != null) {
				try {
					statement.close();
				} catch (SQLException e) {
				}
			}
		}
	}
}
