#!/usr/bin/perl

use strict;
use warnings;

my %stat;
my %prev;
my %flag;

my $datetime;

while (my $line = <STDIN>) {
    chomp($line);
    
    if ($line =~ /^(\d+-\d+-\d+ \d+:\d+:\d+)/) {
        $datetime = $1;
    } else {
        my ($key, $value) = split(/\t/, $line);
        $stat{$datetime}->{$key} = $value;
        
        if (defined($prev{$key}) and $value ne $prev{$key}) {
            $flag{$key} = 1;
        }
        
        $prev{$key} = $value;
    }
}

print 'Datetime';
foreach my $key (sort keys %flag) {
    print ",$key";
}
print "\n";

foreach my $datetime (sort keys %stat) {
    print $datetime;
    foreach my $key (sort keys %flag) {
        print ',' . $stat{$datetime}->{$key};
    }
    print "\n";
}
